
__no_init
struct
{
 u8 init;
 
 u32 crystal_frq;
 u16 sw_frq;
 u16 pwm_frq;
 u16 Vdd;
 u16 R1;
 u16 R2;
 u16 IsR;
 u16 Irst;
 u16 V_output;
 u16 Ktr;
 u16 LoBt_trs;


} eep @ 0x4000; 

class //periph_init
{
 public:
 void gpio()
 {
  PA_CR1 = 0xff;
  PA_ODR = 0;  
  PA_DDR = 0;

  PB_CR1 = 1<<7|1<<6|1<<3|1<<1|1;
  PB_ODR = 1<<5|1<<1|1;
  PB_DDR = 1<<1|1;

  PC_CR1 = 0xff;
  PC_ODR = 1<<2|1<<1;
  PC_DDR = 0xff;

  PD_CR1 = 0xff;
  PD_ODR = 0;
  PD_DDR = 0xff;

  PE_CR1 = 0xff;
  PE_ODR = 0;
  PE_DDR = 0xff;

  PF_CR1 = 0xff;
  PF_ODR = 0;
  PF_DDR = 0;
 }
 bool clk()
 {
  CLK_DeInit();
  CLK->ECKR  = CLK_ECKR_HSEEN;
  CLK->PCKENR1 = CLK_PCKENR1_TIM1|CLK_PCKENR1_TIM2;
  CLK->CKDIVR = 0;
  for(volatile u16 i=0xffff;i;i--)
  {
   if(CLK->ECKR&CLK_ECKR_HSERDY)
   {
    CLK->SWR   = 0xb4;
    while(!(CLK->SWCR&CLK_SWCR_SWIF));
    CLK->SWCR |= CLK_SWCR_SWEN;
    CLK->SWCR = 0;
    dbuf[0]='E';
    
    CLK->CSSR = CLK_CSSR_CSSEN|CLK_CSSR_CSSDIE;
    
    return 1;
   }
  }
   
  return 0; 
 }
 void t1(u16 arr)
 {
  {
   TIM1->ARRH    = arr>>8;
   TIM1->ARRL    = (u8)arr;
   TIM1->CR1     = TIM1_COUNTERMODE_CENTERALIGNED1|TIM1_CR1_URS;
   TIM1->CR2     = TIM1_CR2_CCPC;
   TIM1->RCR     = 1;
   TIM1->IER     = TIM1_IER_UIE;
  }

  TIM1->CR2  |= TIM1_CR2_MMS;
  TIM1->CCR4L = 0xfd;
  TIM1->CCMR4 = TIM1_OCMODE_PWM1;

  TIM1->CCER1 = 0xff;
  TIM1->CCMR1 = TIM1_OCMODE_PWM1|TIM1_CCMR_OCxPE;
  TIM1->CCMR2|= 0x40|TIM1_CCMR_OCxPE;

  TIM1->EGR  |= TIM1_EGR_COMG;

  TIM1->DTR   = 10; // dt delay (*62ns)
  TIM1->CR1  |= TIM1_CR1_CEN;
  TIM1->BKR  |= TIM1_LOCKLEVEL_1;

 }
 void t2()  
 {
  u32 x=1;

  for(u8 i=1;i<0x0f+1;i++)
  {
   x=x*2;
   if(eep.crystal_frq/x<0xffff){TIM2->PSCR=i; break;}
  }

  TIM2->ARRH  = (u32)eep.crystal_frq/(x*t2_interrupt_rate)-1>>8;
  TIM2->ARRL  = (u8)(eep.crystal_frq/(x*t2_interrupt_rate)-1);

  TIM2->IER   = 1;
  TIM2->CR1   = 1;
 }
 void t4()  
 {
   TIM4->ARR   = 0xff;
   TIM4->PSCR  = 7;
   TIM4->IER   = 1;
   TIM4->CR1   = 1;
 }
 void adc()
 {
  ADC1->CR1  = ADC1_PRESSEL_FCPU_D6;
  ADC1->CR2  = ADC1_ALIGN_LEFT|ADC1_CR2_EXTTRIG;
  ADC1->CSR  = 2;
  ADC1->TDRL = 0x0f;
  ADC1->CR1 |= ADC1_CR1_ADON;
 } 
 void iwdg()
 {
  IWDG_Enable();
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
  IWDG_SetPrescaler(IWDG_Prescaler_256);
  IWDG_SetReload(1); 
  IWDG_ReloadCounter();
 }
 void ee()
 {
#define sgn 222
  if(eep.init!=sgn)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);
   eep.init = sgn;
   
   eep.crystal_frq = 13824E3; //Hz
   eep.sw_frq      = 50;      //Hz   
   eep.pwm_frq     = 15E3;    //Hz   
   eep.Vdd         = 5000;    //mV   
   eep.R1          = 20E3;    //Ohm   
   eep.R2          = 10E3;    //Ohm    
   eep.IsR         = 30;      //mOhm  
   eep.Irst        = 30;      //A
   eep.V_output    = 220;     //V   
   eep.Ktr         = 28;      //turn ratio
   eep.LoBt_trs    = 1050;    //mV*10
   
   FLASH_Lock(FLASH_MEMTYPE_DATA);
  }
 }
}cfg;

